%define module megaraid2
%define version v2.10.10.1

Summary:	megaraid2 dkms package
Name:		%{module}
Version:	%{version}
Release:	1dkms
Vendor:		LSI
License:	GPL
Packager:	Rajesh Prabhakaran (rajesh.prabhakaran@lsil.com)
Group:		System Environment/Base
BuildArch:	i686
Requires:	dkms >= 1.00
Requires:	bash
Source0:	%{module}-%{version}-src.tgz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root/

%description
This package contains LSI's megaraid2 module wrapped for the DKMS framework.

%prep
rm -rf %{module}-%{version}
mkdir %{module}-%{version}
cd %{module}-%{version}
tar xvzf $RPM_SOURCE_DIR/%{module}-%{version}-src.tgz

%install
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi

mkdir -p $RPM_BUILD_ROOT/usr/src/%{module}-%{version}/
mkdir -p $RPM_BUILD_ROOT/usr/src/%{module}-%{version}/patches
mkdir -p $RPM_BUILD_ROOT/usr/src/%{module}-%{version}/redhat_driver_disk

cp -rf %{module}-%{version}/* $RPM_BUILD_ROOT/usr/src/%{module}-%{version}

install -m 644 $RPM_SOURCE_DIR/%{module}-%{version}-kernel2.4.21-4.EL-i686.tgz $RPM_BUILD_ROOT/usr/src/%{module}-%{version}
install -m 644 $RPM_SOURCE_DIR/%{module}-%{version}-kernel2.4.9-e.34-i686.tgz $RPM_BUILD_ROOT/usr/src/%{module}-%{version}

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(0644,root,root)
/usr/src/%{module}-%{version}/

%pre

%post
dkms add -m %{module} -v %{version} --rpm_safe_upgrade

# Load tarballs as necessary
loaded_tarballs=""

base_kernel=2.4.21-4.EL		# this is the archive of all related kernels
for kernel_name in 2.4.21-4.EL; do
        if [ -d "/lib/modules/$kernel_name" ] && [ `uname -m | grep -c "i*86"` -gt 0 ]; then
                echo -e ""
                echo -e "Loading/Installing pre-built modules for $kernel_name."
                dkms ldtarball --archive=/usr/src/%{module}-%{version}/%{module}-%{version}-kernel2.4.21-4.EL-i686.tgz >/dev/null
                dkms install -m %{module} -v %{version} -k ${kernel_name} >/dev/null 2>&1
                dkms install -m %{module} -v %{version} -k ${kernel_name}smp >/dev/null 2>&1
                dkms install -m %{module} -v %{version} -k ${kernel_name}hugemem >/dev/null 2>&1
		[ `uname -r | grep -c "$kernel_name"` -gt 0 ] && loaded_tarballs="true"
        fi
done

base_kernel=2.4.9-e.34		# this is the archive of all related kernels
for kernel_name in 2.4.9-e.34; do
        if [ -d "/lib/modules/$kernel_name" ] && [ `uname -m | grep -c "i*86"` -gt 0 ]; then
                echo -e ""
                echo -e "Loading/Installing pre-built modules for $kernel_name."
                dkms ldtarball --archive=/usr/src/%{module}-%{version}/%{module}-%{version}-kernel2.4.9-e.34-i686.tgz >/dev/null
                dkms install -m %{module} -v %{version} -k ${kernel_name} >/dev/null 2>&1
                dkms install -m %{module} -v %{version} -k ${kernel_name}smp >/dev/null 2>&1
                dkms install -m %{module} -v %{version} -k ${kernel_name}enterprise >/dev/null 2>&1
		[ `uname -r | grep -c "$kernel_name"` -gt 0 ] && loaded_tarballs="true"
        fi
done

# If we haven't loaded a tarball, then try building it for the current kernel
if [ -z "$loaded_tarballs" ]; then
	if [ `uname -r | grep -c "BOOT"` -eq 0 ] && [ -e /lib/modules/`uname -r`/build/include ]; then
		dkms build -m %{module} -v %{version}
		dkms install -m %{module} -v %{version}
	elif [ `uname -r | grep -c "BOOT"` -gt 0 ]; then
		echo -e ""
		echo -e "Module build for the currently running kernel was skipped since you"
		echo -e "are running a BOOT variant of the kernel."
	else 
		echo -e ""
		echo -e "Module build for the currently running kernel was skipped since the"
		echo -e "kernel source for this kernel does not seem to be installed."
	fi
fi
exit 0

%preun
echo -e
echo -e "Uninstall of megaraid2 module (version %{version}) beginning:"
dkms remove -m %{module} -v %{version} --all --rpm_safe_upgrade
exit 0

%changelog
* Thu Dec 16 2004 Atul Mukker <atulm@lsil.com>
- Released for megaraid2 v2.10.9.0 for built-in lk 2.4.9-e.34, 2.4.21-4.EL
* Fri May 21 2004 Sreenivas Bagalkote <Sreenivas.Bagalkote@lsil.com>
- Released for megaraid2 v2.10.6 for built-in lk 2.4.9-e.3, 2.4.9-e.34, 2.4.21-4.EL
* Thu May 20 2004 Sreenivas Bagalkote <Sreenivas.Bagalkote@lsil.com>
- Released for megaraid2 v2.10.6 for built-in lk 2.4.9-e.3, 2.4.9-e.34, 2.4.21-4.EL, 2.4.21-15.EL
* Fri May 14 2004 Sreenivas Bagalkote <Sreenivas.Bagalkote@lsil.com>
- Released for megaraid2 v2.10.6 for built-in lk 2.4.20-6, 2.4.20-8, 2.4.9-e.3, 2.4.9-e.34, 2.4.21-4.EL, 2.4.21-15.EL
* Wed May  5 2004 Sreenivas Bagalkote <Sreenivas.Bagalkote@lsil.com>
- Released for megaraid2 v2.10.4 for built-in lk 2.4.20-6, 2.4.20-8, 2.4.9-e.3, 2.4.9-e.34, 2.4.21-4.EL, 2.4.21-12.EL
* Wed Apr 28 2004 Sreenivas Bagalkote <Sreenivas.Bagalkote@lsil.com>
- Released for megaraid2 v2.10.3 for built-in lk 2.4.20-6, 2.4.20-8, 2.4.9-e.3, 2.4.9-e.34, 2.4.21-4.EL, 2.4.21-12.EL
* Thu Apr 22 2004 Sreenias Bagalkote <Sreenivas.Bagalkote@lsil.com>
- Released for megaraid2 v2.10.3 for built-in lk 2.4.20-6, 2.4.20-8, 2.4.9-e.3, 2.4.9-e.34, 2.4.21-4.EL, 2.4.21-12.EL
* Tue Mar 26 2004 Atul Mukker <Atul.Mukker@lsil.com>
- Released for megaraid2 v2.10.1 for built-in lk 2.4.20-6, 2.4.20-8, 2.4.9-e.3, 2.4.9-e.34, 2.4.21-4.EL
* Tue Mar 23 2004 Atul Mukker <Atul.Mukker@lsil.com>
- Released for megaraid2 v2.10.1 for built-in lk 2.4.20-6, 2.4.20-8, 2.4.9-e.3, 2.4.9-e.34, 2.4.21-4.EL
* Wed Feb 11 2004 Atul Mukker <Atul.Mukker@lsil.com>
- Released for megaraid2 2.10.1 for built-in lk 2.4.21-4.EL and lk 2.4.21-9.EL
